(*
This file is part of the first order theorem prover Darwin
Copyright (C) 2005
              The University of Iowa

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*)

(** lemma generation

    computes a lemma, i.e. a clause entailed by the problem clause set,
    from a closing context unifier.
*)


(** {6 Types} *)

type state = State.state
type choice_point = State.choice_point
type literal = Term.literal
type clause = Term.clause


(** {6 Functions} *)

(** [get_lemma state closing_clause context_literals]
    computes a lemma from the closing context unifier given
    by the [closing_clause] and the used [context_literals],
    using the dependency information of [state]
    to regress the implied context literals. *)
val get_lemma: state -> clause -> literal array -> clause option
